/* set-wallpaper.c generated by valac 0.56.8, the Vala compiler
 * generated from set-wallpaper.vala, do not modify */

/*
* Copyright 2017-2022 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define SET_WALLPAPER_CONTRACTOR_DEFAULT_TRANSITION_DURATION 1
#define SET_WALLPAPER_CONTRACTOR_SLIDESHOW_FILENAME "slideshow.xml"
#define SET_WALLPAPER_CONTRACTOR_SLIDESHOW_TEMPLATE "\n    <background>\n        %s\n    </background>"
#define SET_WALLPAPER_CONTRACTOR_SLIDESHOW_WALLPAPER_TEMPLATE "\n" \
"        <static>\n" \
"            <duration>%i</duration>\n" \
"            <file>%s</file>\n" \
"        </static>\n" \
"        <transition>\n" \
"            <duration>%i</duration>\n" \
"            <from>%s</from>\n" \
"            <to>%s</to>\n" \
"        </transition>\n" \
"    "
#define CONSTANTS_GETTEXT_DOMAIN "pantheon-desktop-plug"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _Block1Data {
	int _ref_count_;
	GtkScale* duration;
	GraniteMessageDialog* dialog;
};

VALA_EXTERN gint set_wallpaper_contractor_delay_value;
gint set_wallpaper_contractor_delay_value = 60;

VALA_EXTERN void set_wallpaper_contractor_update_slideshow (const gchar* path,
                                                GList* files,
                                                gint duration);
VALA_EXTERN void set_wallpaper_contractor_set_settings_key (const gchar* uri);
VALA_EXTERN void set_wallpaper_contractor_delay_value_changed (GtkScale* duration_scale,
                                                   GtkLabel* duration_label);
VALA_EXTERN gchar* set_wallpaper_contractor_get_local_bg_directory (void);
VALA_EXTERN GFile* set_wallpaper_contractor_ensure_local_bg_exists (void);
VALA_EXTERN GFile* set_wallpaper_contractor_copy_for_library (GFile* source);
static gint set_wallpaper_contractor_main (gchar** args,
                                    gint args_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__gtk_range_value_changed (GtkRange* _sender,
                                          gpointer self);

void
set_wallpaper_contractor_update_slideshow (const gchar* path,
                                           GList* files,
                                           gint duration)
{
	gchar* wallpapers = NULL;
	gchar* _tmp0_;
	guint len = 0U;
	gchar* slideshow = NULL;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	_tmp0_ = g_strdup ("");
	wallpapers = _tmp0_;
	len = g_list_length (files);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gchar* slide = NULL;
				gconstpointer _tmp3_;
				gchar* _tmp4_;
				gint _tmp5_ = 0;
				gchar* next_slide = NULL;
				gconstpointer _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(((guint) i) < len)) {
					break;
				}
				_tmp3_ = g_list_nth_data (files, (guint) i);
				_tmp4_ = g_file_get_path ((GFile*) _tmp3_);
				slide = _tmp4_;
				if (((guint) (i - 1)) == len) {
					_tmp5_ = 0;
				} else {
					_tmp5_ = i;
				}
				_tmp6_ = g_list_nth_data (files, (guint) _tmp5_);
				_tmp7_ = g_file_get_path ((GFile*) _tmp6_);
				next_slide = _tmp7_;
				_tmp8_ = wallpapers;
				_tmp9_ = slide;
				_tmp10_ = slide;
				_tmp11_ = next_slide;
				_tmp12_ = g_strdup_printf (SET_WALLPAPER_CONTRACTOR_SLIDESHOW_WALLPAPER_TEMPLATE, duration, _tmp9_, SET_WALLPAPER_CONTRACTOR_DEFAULT_TRANSITION_DURATION, _tmp10_, _tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
				_g_free0 (wallpapers);
				wallpapers = _tmp14_;
				_g_free0 (_tmp13_);
				_g_free0 (next_slide);
				_g_free0 (slide);
			}
		}
	}
	_tmp15_ = wallpapers;
	_tmp16_ = g_strdup_printf (SET_WALLPAPER_CONTRACTOR_SLIDESHOW_TEMPLATE, _tmp15_);
	slideshow = _tmp16_;
	{
		g_file_set_contents (path, slideshow, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp17_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = e->message;
		g_error ("set-wallpaper.vala:59: %s", _tmp17_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (slideshow);
		_g_free0 (wallpapers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp18_ = g_strconcat ("file://", path, NULL);
	_tmp19_ = _tmp18_;
	set_wallpaper_contractor_set_settings_key (_tmp19_);
	_g_free0 (_tmp19_);
	_g_free0 (slideshow);
	_g_free0 (wallpapers);
}

void
set_wallpaper_contractor_set_settings_key (const gchar* uri)
{
	GSettings* settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	GSettings* _tmp8_;
	g_return_if_fail (uri != NULL);
	_tmp0_ = g_settings_new ("org.gnome.desktop.background");
	settings = _tmp0_;
	_tmp1_ = settings;
	g_settings_set_string (_tmp1_, "picture-uri", uri);
	_tmp2_ = settings;
	g_settings_reset (_tmp2_, "color-shading-type");
	_tmp3_ = settings;
	_tmp4_ = g_settings_get_string (_tmp3_, "picture-options");
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strcmp0 (_tmp5_, "none") == 0;
	_g_free0 (_tmp5_);
	if (_tmp6_) {
		GSettings* _tmp7_;
		_tmp7_ = settings;
		g_settings_reset (_tmp7_, "picture-options");
	}
	_tmp8_ = settings;
	g_settings_apply (_tmp8_);
	g_settings_sync ();
	_g_object_unref0 (settings);
}

void
set_wallpaper_contractor_delay_value_changed (GtkScale* duration_scale,
                                              GtkLabel* duration_label)
{
	gdouble value = 0.0;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gchar* text = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_if_fail (duration_scale != NULL);
	g_return_if_fail (duration_label != NULL);
	_tmp0_ = gtk_range_get_adjustment ((GtkRange*) duration_scale);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	value = _tmp3_;
	set_wallpaper_contractor_delay_value = (gint) (((((pow (value, (gdouble) 5) / pow ((gdouble) 90, (gdouble) 5)) * 60) * 60) * 24) + 5);
	if (set_wallpaper_contractor_delay_value < 60) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_DOMAIN, "%d second", "%d seconds", (gulong) set_wallpaper_contractor_delay_value), set_wallpaper_contractor_delay_value);
		_g_free0 (text);
		text = _tmp4_;
	} else {
		if (set_wallpaper_contractor_delay_value < (60 * 60)) {
			gint minutes = 0;
			gchar* _tmp5_;
			minutes = set_wallpaper_contractor_delay_value / 60;
			_tmp5_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_DOMAIN, "%d minute", "%d minutes", (gulong) minutes), minutes);
			_g_free0 (text);
			text = _tmp5_;
			set_wallpaper_contractor_delay_value = minutes * 60;
		} else {
			if (set_wallpaper_contractor_delay_value < ((60 * 60) * 24)) {
				gint hours = 0;
				gchar* _tmp6_;
				hours = set_wallpaper_contractor_delay_value / (60 * 60);
				_tmp6_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_DOMAIN, "%d hour", "%d hours", (gulong) hours), hours);
				_g_free0 (text);
				text = _tmp6_;
				set_wallpaper_contractor_delay_value = hours * (60 * 60);
			} else {
				gchar* _tmp7_;
				_tmp7_ = g_strdup (_ ("1 day"));
				_g_free0 (text);
				text = _tmp7_;
				set_wallpaper_contractor_delay_value = (60 * 60) * 24;
			}
		}
	}
	_tmp8_ = g_strconcat (_ ("Show each photo for"), " <b>", NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = text;
	_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat (_tmp12_, "</b>", NULL);
	_tmp14_ = _tmp13_;
	gtk_label_set_markup (duration_label, _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp9_);
	_g_free0 (text);
}

gchar*
set_wallpaper_contractor_get_local_bg_directory (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	_tmp0_ = g_get_user_data_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "backgrounds", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

GFile*
set_wallpaper_contractor_ensure_local_bg_exists (void)
{
	GFile* folder = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
	GFile* result;
	_tmp0_ = set_wallpaper_contractor_get_local_bg_directory ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	folder = _tmp3_;
	_tmp4_ = folder;
	if (!g_file_query_exists (_tmp4_, NULL)) {
		{
			GFile* _tmp5_;
			_tmp5_ = folder;
			g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_warning ("set-wallpaper.vala:115: %s\n", _tmp7_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (folder);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = folder;
	return result;
}

GFile*
set_wallpaper_contractor_copy_for_library (GFile* source)
{
	GFile* dest = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result;
	g_return_val_if_fail (source != NULL, NULL);
	dest = NULL;
	{
		gchar* timestamp = NULL;
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* filename = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* path = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		_tmp0_ = g_date_time_new_now_local ();
		_tmp1_ = _tmp0_;
		_tmp2_ = g_date_time_format (_tmp1_, "%Y-%m-%d-%H-%M-%S");
		_tmp3_ = _tmp2_;
		_g_date_time_unref0 (_tmp1_);
		timestamp = _tmp3_;
		_tmp4_ = g_file_get_basename (source);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%s-%s", timestamp, _tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		filename = _tmp7_;
		_tmp8_ = set_wallpaper_contractor_get_local_bg_directory ();
		_tmp9_ = _tmp8_;
		_tmp10_ = g_build_filename (_tmp9_, filename, NULL);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		path = _tmp11_;
		_tmp12_ = g_file_new_for_path (path);
		_g_object_unref0 (dest);
		dest = _tmp12_;
		_tmp13_ = dest;
		g_file_copy (source, _tmp13_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (path);
			_g_free0 (filename);
			_g_free0 (timestamp);
			goto __catch0_g_error;
		}
		_g_free0 (path);
		_g_free0 (filename);
		_g_free0 (timestamp);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		g_warning ("set-wallpaper.vala:132: %s\n", _tmp15_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dest);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = dest;
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->dialog);
		_g_object_unref0 (_data1_->duration);
		g_slice_free (Block1Data, _data1_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
__lambda4_ (Block1Data* _data1_)
{
	GtkScale* _tmp0_;
	GraniteMessageDialog* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	_tmp0_ = _data1_->duration;
	_tmp1_ = _data1_->dialog;
	_tmp2_ = granite_message_dialog_get_secondary_label (_tmp1_);
	_tmp3_ = _tmp2_;
	set_wallpaper_contractor_delay_value_changed (_tmp0_, _tmp3_);
}

static void
___lambda4__gtk_range_value_changed (GtkRange* _sender,
                                     gpointer self)
{
	__lambda4_ (self);
}

static gint
set_wallpaper_contractor_main (gchar** args,
                               gint args_length1)
{
	Block1Data* _data1_;
	GFile* folder = NULL;
	GFile* _tmp0_;
	GList* files = NULL;
	GList* _tmp21_;
	GList* _tmp22_;
	GtkScale* _tmp27_ = NULL;
	GtkScale* _tmp28_;
	GThemedIcon* _tmp29_;
	GraniteMessageDialog* _tmp30_ = NULL;
	GraniteMessageDialog* _tmp31_;
	GraniteMessageDialog* _tmp32_;
	GraniteMessageDialog* _tmp33_;
	GtkBin* _tmp34_;
	GtkBin* _tmp35_;
	GtkScale* _tmp36_;
	GraniteMessageDialog* _tmp37_;
	GtkScale* _tmp38_;
	GraniteMessageDialog* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GtkScale* _tmp42_;
	GraniteMessageDialog* _tmp43_;
	gint result;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	gtk_init ((gint*) (&args_length1), &args);
	_tmp0_ = set_wallpaper_contractor_ensure_local_bg_exists ();
	folder = _tmp0_;
	files = NULL;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GFile* file = NULL;
				const gchar* _tmp3_;
				GFile* _tmp4_;
				GFile* _tmp5_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < args_length1)) {
					break;
				}
				_tmp3_ = args[i];
				_tmp4_ = g_file_new_for_path (_tmp3_);
				file = _tmp4_;
				_tmp5_ = file;
				if (_tmp5_ != NULL) {
					gchar* path = NULL;
					GFile* _tmp6_;
					gchar* _tmp7_;
					GFile* append_file = NULL;
					GFile* _tmp8_;
					GFile* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean _tmp13_;
					GFile* _tmp19_;
					GFile* _tmp20_;
					_tmp6_ = file;
					_tmp7_ = g_file_get_path (_tmp6_);
					path = _tmp7_;
					_tmp8_ = file;
					_tmp9_ = _g_object_ref0 (_tmp8_);
					append_file = _tmp9_;
					_tmp10_ = path;
					_tmp11_ = set_wallpaper_contractor_get_local_bg_directory ();
					_tmp12_ = _tmp11_;
					_tmp13_ = !g_str_has_prefix (_tmp10_, _tmp12_);
					_g_free0 (_tmp12_);
					if (_tmp13_) {
						GFile* local_file = NULL;
						GFile* _tmp14_;
						GFile* _tmp15_;
						GFile* _tmp16_;
						_tmp14_ = file;
						_tmp15_ = set_wallpaper_contractor_copy_for_library (_tmp14_);
						local_file = _tmp15_;
						_tmp16_ = local_file;
						if (_tmp16_ != NULL) {
							GFile* _tmp17_;
							GFile* _tmp18_;
							_tmp17_ = local_file;
							_tmp18_ = _g_object_ref0 (_tmp17_);
							_g_object_unref0 (append_file);
							append_file = _tmp18_;
						}
						_g_object_unref0 (local_file);
					}
					_tmp19_ = append_file;
					_tmp20_ = _g_object_ref0 (_tmp19_);
					files = g_list_append (files, _tmp20_);
					_g_object_unref0 (append_file);
					_g_free0 (path);
				}
				_g_object_unref0 (file);
			}
		}
	}
	_tmp21_ = files;
	if (g_list_length (_tmp21_) < ((guint) 1)) {
		g_warning ("set-wallpaper.vala:162: No images specified, aborting.\n");
		result = 1;
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
		_g_object_unref0 (folder);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	_tmp22_ = files;
	if (g_list_length (_tmp22_) == ((guint) 1)) {
		GList* _tmp23_;
		gconstpointer _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp23_ = files;
		_tmp24_ = _tmp23_->data;
		_tmp25_ = g_file_get_uri ((GFile*) _tmp24_);
		_tmp26_ = _tmp25_;
		set_wallpaper_contractor_set_settings_key (_tmp26_);
		_g_free0 (_tmp26_);
		result = 0;
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
		_g_object_unref0 (folder);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	_tmp27_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 10);
	gtk_scale_set_draw_value (_tmp27_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
	g_object_ref_sink (_tmp27_);
	_data1_->duration = _tmp27_;
	_tmp28_ = _data1_->duration;
	gtk_range_set_value ((GtkRange*) _tmp28_, (gdouble) 50);
	_tmp29_ = (GThemedIcon*) g_themed_icon_new ("media-playback-start");
	_tmp30_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Set As Desktop Slideshow"), "", "preferences-desktop-wallpaper", GTK_BUTTONS_CANCEL);
	granite_message_dialog_set_badge_icon (_tmp30_, (GIcon*) _tmp29_);
	_g_object_unref0 (_tmp29_);
	g_object_ref_sink (_tmp30_);
	_data1_->dialog = _tmp30_;
	_tmp31_ = _data1_->dialog;
	gtk_dialog_add_button ((GtkDialog*) _tmp31_, _ ("Create Slideshow"), (gint) GTK_RESPONSE_OK);
	_tmp32_ = _data1_->dialog;
	gtk_dialog_set_default_response ((GtkDialog*) _tmp32_, (gint) GTK_RESPONSE_OK);
	_tmp33_ = _data1_->dialog;
	_tmp34_ = granite_message_dialog_get_custom_bin (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = _data1_->duration;
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = _data1_->dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp37_);
	_tmp38_ = _data1_->duration;
	_tmp39_ = _data1_->dialog;
	_tmp40_ = granite_message_dialog_get_secondary_label (_tmp39_);
	_tmp41_ = _tmp40_;
	set_wallpaper_contractor_delay_value_changed (_tmp38_, _tmp41_);
	_tmp42_ = _data1_->duration;
	g_signal_connect_data ((GtkRange*) _tmp42_, "value-changed", (GCallback) ___lambda4__gtk_range_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp43_ = _data1_->dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp43_) == ((gint) GTK_RESPONSE_OK)) {
		GraniteMessageDialog* _tmp44_;
		gchar* path = NULL;
		GFile* _tmp45_;
		GFile* _tmp46_;
		GFile* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		const gchar* _tmp50_;
		GList* _tmp51_;
		_tmp44_ = _data1_->dialog;
		gtk_widget_destroy ((GtkWidget*) _tmp44_);
		_tmp45_ = folder;
		_tmp46_ = g_file_get_child (_tmp45_, SET_WALLPAPER_CONTRACTOR_SLIDESHOW_FILENAME);
		_tmp47_ = _tmp46_;
		_tmp48_ = g_file_get_path (_tmp47_);
		_tmp49_ = _tmp48_;
		_g_object_unref0 (_tmp47_);
		path = _tmp49_;
		_tmp50_ = path;
		_tmp51_ = files;
		set_wallpaper_contractor_update_slideshow (_tmp50_, _tmp51_, set_wallpaper_contractor_delay_value);
		result = 0;
		_g_free0 (path);
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
		_g_object_unref0 (folder);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return result;
	}
	result = 1;
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
	_g_object_unref0 (folder);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return set_wallpaper_contractor_main (argv, argc);
}

