/* Dock.c generated by valac 0.56.8, the Vala compiler
 * generated from Dock.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0-or-later
 * SPDX-FileCopyrightText: 2016-2023 elementary, Inc. (https://elementary.io)
 */

#include "pantheon-desktop.h"
#include <gtk/gtk.h>
#include <plank.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <libgnome-desktop/gnome-rr.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <handy.h>

#define PANTHEON_SHELL_DOCK_PANEL_SCHEMA "io.elementary.desktop.wingpanel"
#define PANTHEON_SHELL_DOCK_TRANSLUCENCY_KEY "use-transparency"

enum  {
	PANTHEON_SHELL_DOCK_0_PROPERTY,
	PANTHEON_SHELL_DOCK_NUM_PROPERTIES
};
static GParamSpec* pantheon_shell_dock_properties[PANTHEON_SHELL_DOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _PantheonShellDockPrivate {
	GtkGrid* display_grid;
	GtkComboBoxText* display_combo;
	PlankDockPreferences* dock_preferences;
};

struct _Block3Data {
	int _ref_count_;
	PantheonShellDock* self;
	GtkRadioButton* never_radio;
	GtkRadioButton* dodge_maximized_radio;
	GtkRadioButton* intelligent_radio;
	GtkRadioButton* window_dodge_radio;
	GtkRadioButton* auto_radio;
	GtkSwitch* display_switch;
	GtkGrid* pressure_grid;
};

static gint PantheonShellDock_private_offset;
static gpointer pantheon_shell_dock_parent_class = NULL;

static void pantheon_shell_dock_check_for_screens (PantheonShellDock* self);
static gint pantheon_shell_dock_find_monitor_number (GdkDisplay* display,
                                              const gchar* plug_name);
static gchar** pantheon_shell_dock_get_monitor_plug_names (GdkDisplay* display,
                                                    gint* result_length1);
static GObject * pantheon_shell_dock_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _pantheon_shell_dock___lambda35_ (PantheonShellDock* self);
static void __pantheon_shell_dock___lambda35__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda36_ (PantheonShellDock* self);
static void __pantheon_shell_dock___lambda36__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda37_ (PantheonShellDock* self);
static void __pantheon_shell_dock___lambda37__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda38_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda38__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda39_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda39__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda40_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda40__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda41_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda41__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda42_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda42__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self);
static void _pantheon_shell_dock___lambda43_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda43__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _pantheon_shell_dock___lambda44_ (Block3Data* _data3_);
static void __pantheon_shell_dock___lambda44__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _pantheon_shell_dock_check_for_screens_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                         gpointer self);
static void pantheon_shell_dock_finalize (GObject * obj);
static GType pantheon_shell_dock_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
pantheon_shell_dock_get_instance_private (PantheonShellDock* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonShellDock_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
pantheon_shell_dock_check_for_screens (PantheonShellDock* self)
{
	gint i = 0;
	gint primary_screen = 0;
	GdkDisplay* default_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkScreen* default_screen = NULL;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	i = 0;
	primary_screen = 0;
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	default_display = _tmp1_;
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	default_screen = _tmp3_;
	_tmp4_ = self->priv->display_combo;
	gtk_combo_box_text_remove_all (_tmp4_);
	{
		GnomeRRScreen* screen = NULL;
		GdkScreen* _tmp5_;
		GnomeRRScreen* _tmp6_;
		_tmp5_ = default_screen;
		_tmp6_ = gnome_rr_screen_new (_tmp5_, &_inner_error0_);
		screen = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			gboolean _tmp7_ = FALSE;
			i = 0;
			_tmp7_ = TRUE;
			while (TRUE) {
				GdkDisplay* _tmp9_;
				gchar* monitor_plug_name = NULL;
				GdkDisplay* _tmp10_;
				GdkMonitor* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GtkComboBoxText* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = default_display;
				if (!(i < gdk_display_get_n_monitors (_tmp9_))) {
					break;
				}
				_tmp10_ = default_display;
				_tmp11_ = gdk_display_get_monitor (_tmp10_, i);
				_tmp12_ = gdk_monitor_get_model (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strdup (_tmp13_);
				monitor_plug_name = _tmp14_;
				_tmp15_ = monitor_plug_name;
				if (_tmp15_ != NULL) {
					GnomeRROutput* output = NULL;
					GnomeRRScreen* _tmp16_;
					const gchar* _tmp17_;
					GnomeRROutput* _tmp18_;
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_ = FALSE;
					GnomeRROutput* _tmp21_;
					_tmp16_ = screen;
					_tmp17_ = monitor_plug_name;
					_tmp18_ = gnome_rr_screen_get_output_by_name (_tmp16_, _tmp17_);
					output = _tmp18_;
					_tmp21_ = output;
					if (_tmp21_ != NULL) {
						GnomeRROutput* _tmp22_;
						const gchar* _tmp23_;
						_tmp22_ = output;
						_tmp23_ = gnome_rr_output_get_display_name (_tmp22_);
						_tmp20_ = _tmp23_ != NULL;
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						GnomeRROutput* _tmp24_;
						const gchar* _tmp25_;
						_tmp24_ = output;
						_tmp25_ = gnome_rr_output_get_display_name (_tmp24_);
						_tmp19_ = g_strcmp0 (_tmp25_, "") != 0;
					} else {
						_tmp19_ = FALSE;
					}
					if (_tmp19_) {
						GtkComboBoxText* _tmp26_;
						GnomeRROutput* _tmp27_;
						const gchar* _tmp28_;
						GnomeRROutput* _tmp29_;
						_tmp26_ = self->priv->display_combo;
						_tmp27_ = output;
						_tmp28_ = gnome_rr_output_get_display_name (_tmp27_);
						gtk_combo_box_text_append_text (_tmp26_, _tmp28_);
						_tmp29_ = output;
						if (gnome_rr_output_get_is_primary (_tmp29_) == TRUE) {
							primary_screen = i;
						}
						_g_free0 (monitor_plug_name);
						continue;
					}
				}
				_tmp30_ = self->priv->display_combo;
				_tmp31_ = g_strdup_printf (_ ("Monitor %d"), i + 1);
				_tmp32_ = _tmp31_;
				gtk_combo_box_text_append_text (_tmp30_, _tmp32_);
				_g_free0 (_tmp32_);
				_g_free0 (monitor_plug_name);
			}
		}
		_g_object_unref0 (screen);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp33_ = e;
		_tmp34_ = _tmp33_->message;
		g_critical ("Dock.vala:340: %s", _tmp34_);
		{
			gboolean _tmp35_ = FALSE;
			i = 0;
			_tmp35_ = TRUE;
			while (TRUE) {
				GdkDisplay* _tmp37_;
				GtkComboBoxText* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				if (!_tmp35_) {
					gint _tmp36_;
					_tmp36_ = i;
					i = _tmp36_ + 1;
				}
				_tmp35_ = FALSE;
				_tmp37_ = default_display;
				if (!(i < gdk_display_get_n_monitors (_tmp37_))) {
					break;
				}
				_tmp38_ = self->priv->display_combo;
				_tmp39_ = g_strdup_printf (_ ("Display %d"), i + 1);
				_tmp40_ = _tmp39_;
				gtk_combo_box_text_append_text (_tmp38_, _tmp40_);
				_g_free0 (_tmp40_);
			}
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (default_screen);
		_g_object_unref0 (default_display);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	if (i <= 1) {
		GtkGrid* _tmp41_;
		GtkGrid* _tmp42_;
		_tmp41_ = self->priv->display_grid;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp41_, TRUE);
		_tmp42_ = self->priv->display_grid;
		gtk_widget_hide ((GtkWidget*) _tmp42_);
	} else {
		PlankDockPreferences* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		GtkGrid* _tmp52_;
		GtkGrid* _tmp53_;
		_tmp43_ = self->priv->dock_preferences;
		_tmp44_ = plank_dock_preferences_get_Monitor (_tmp43_);
		_tmp45_ = _tmp44_;
		if (g_strcmp0 (_tmp45_, "") != 0) {
			GtkComboBoxText* _tmp46_;
			GdkDisplay* _tmp47_;
			PlankDockPreferences* _tmp48_;
			const gchar* _tmp49_;
			const gchar* _tmp50_;
			_tmp46_ = self->priv->display_combo;
			_tmp47_ = gtk_widget_get_display ((GtkWidget*) self);
			_tmp48_ = self->priv->dock_preferences;
			_tmp49_ = plank_dock_preferences_get_Monitor (_tmp48_);
			_tmp50_ = _tmp49_;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp46_, pantheon_shell_dock_find_monitor_number (_tmp47_, _tmp50_));
		} else {
			GtkComboBoxText* _tmp51_;
			_tmp51_ = self->priv->display_combo;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp51_, primary_screen);
		}
		_tmp52_ = self->priv->display_grid;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp52_, FALSE);
		_tmp53_ = self->priv->display_grid;
		gtk_widget_show_all ((GtkWidget*) _tmp53_);
	}
	_g_object_unref0 (default_screen);
	_g_object_unref0 (default_display);
}

static gchar**
pantheon_shell_dock_get_monitor_plug_names (GdkDisplay* display,
                                            gint* result_length1)
{
	gint n_monitors = 0;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result;
	g_return_val_if_fail (display != NULL, NULL);
	n_monitors = gdk_display_get_n_monitors (display);
	_tmp0_ = g_new0 (gchar*, n_monitors + 1);
	_result_ = _tmp0_;
	_result__length1 = n_monitors;
	__result__size_ = _result__length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gchar** _tmp3_;
				gint _tmp3__length1;
				GdkMonitor* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < n_monitors)) {
					break;
				}
				_tmp3_ = _result_;
				_tmp3__length1 = _result__length1;
				_tmp4_ = gdk_display_get_monitor (display, i);
				_tmp5_ = gdk_monitor_get_model (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = g_strdup (_tmp6_);
				_g_free0 (_tmp3_[i]);
				_tmp3_[i] = _tmp7_;
			}
		}
	}
	_tmp8_ = _result_;
	_tmp8__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gint
pantheon_shell_dock_find_monitor_number (GdkDisplay* display,
                                         const gchar* plug_name)
{
	gint n_monitors = 0;
	gint result;
	g_return_val_if_fail (display != NULL, 0);
	g_return_val_if_fail (plug_name != NULL, 0);
	n_monitors = gdk_display_get_n_monitors (display);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GdkMonitor* monitor = NULL;
				GdkMonitor* _tmp2_;
				GdkMonitor* _tmp3_;
				gchar* name = NULL;
				GdkMonitor* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < n_monitors)) {
					break;
				}
				_tmp2_ = gdk_display_get_monitor (display, i);
				_tmp3_ = _g_object_ref0 (_tmp2_);
				monitor = _tmp3_;
				_tmp4_ = monitor;
				_tmp5_ = gdk_monitor_get_model (_tmp4_);
				_tmp6_ = g_strdup (_tmp5_);
				name = _tmp6_;
				_tmp7_ = name;
				if (g_strcmp0 (plug_name, _tmp7_) == 0) {
					result = i;
					_g_free0 (name);
					_g_object_unref0 (monitor);
					return result;
				}
				_g_free0 (name);
				_g_object_unref0 (monitor);
			}
		}
	}
	result = gdk_display_get_n_monitors (display);
	return result;
}

PantheonShellDock*
pantheon_shell_dock_construct (GType object_type)
{
	PantheonShellDock * self = NULL;
	self = (PantheonShellDock*) g_object_new (object_type, NULL);
	return self;
}

PantheonShellDock*
pantheon_shell_dock_new (void)
{
	return pantheon_shell_dock_construct (PANTHEON_SHELL_TYPE_DOCK);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		PantheonShellDock* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->pressure_grid);
		_g_object_unref0 (_data3_->display_switch);
		_g_object_unref0 (_data3_->auto_radio);
		_g_object_unref0 (_data3_->window_dodge_radio);
		_g_object_unref0 (_data3_->intelligent_radio);
		_g_object_unref0 (_data3_->dodge_maximized_radio);
		_g_object_unref0 (_data3_->never_radio);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
_pantheon_shell_dock___lambda35_ (PantheonShellDock* self)
{
	PlankDockPreferences* _tmp0_;
	_tmp0_ = self->priv->dock_preferences;
	plank_dock_preferences_set_IconSize (_tmp0_, 32);
}

static void
__pantheon_shell_dock___lambda35__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda35_ ((PantheonShellDock*) self);
}

static void
_pantheon_shell_dock___lambda36_ (PantheonShellDock* self)
{
	PlankDockPreferences* _tmp0_;
	_tmp0_ = self->priv->dock_preferences;
	plank_dock_preferences_set_IconSize (_tmp0_, 48);
}

static void
__pantheon_shell_dock___lambda36__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda36_ ((PantheonShellDock*) self);
}

static void
_pantheon_shell_dock___lambda37_ (PantheonShellDock* self)
{
	PlankDockPreferences* _tmp0_;
	_tmp0_ = self->priv->dock_preferences;
	plank_dock_preferences_set_IconSize (_tmp0_, 64);
}

static void
__pantheon_shell_dock___lambda37__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda37_ ((PantheonShellDock*) self);
}

static void
_pantheon_shell_dock___lambda38_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkGrid* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->pressure_grid;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
	_tmp1_ = _data3_->never_radio;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PlankDockPreferences* _tmp4_;
		_tmp4_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp4_, PLANK_HIDE_TYPE_NONE);
	}
}

static void
__pantheon_shell_dock___lambda38__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda38_ (self);
}

static void
_pantheon_shell_dock___lambda39_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkGrid* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->pressure_grid;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = _data3_->dodge_maximized_radio;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PlankDockPreferences* _tmp4_;
		_tmp4_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp4_, PLANK_HIDE_TYPE_DODGE_MAXIMIZED);
	}
}

static void
__pantheon_shell_dock___lambda39__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda39_ (self);
}

static void
_pantheon_shell_dock___lambda40_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkGrid* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->pressure_grid;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = _data3_->intelligent_radio;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PlankDockPreferences* _tmp4_;
		_tmp4_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp4_, PLANK_HIDE_TYPE_INTELLIGENT);
	}
}

static void
__pantheon_shell_dock___lambda40__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda40_ (self);
}

static void
_pantheon_shell_dock___lambda41_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkGrid* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->pressure_grid;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = _data3_->window_dodge_radio;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PlankDockPreferences* _tmp4_;
		_tmp4_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp4_, PLANK_HIDE_TYPE_WINDOW_DODGE);
	}
}

static void
__pantheon_shell_dock___lambda41__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda41_ (self);
}

static void
_pantheon_shell_dock___lambda42_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkGrid* _tmp0_;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->pressure_grid;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
	_tmp1_ = _data3_->auto_radio;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PlankDockPreferences* _tmp4_;
		_tmp4_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp4_, PLANK_HIDE_TYPE_AUTO);
	}
}

static void
__pantheon_shell_dock___lambda42__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                             gpointer self)
{
	_pantheon_shell_dock___lambda42_ (self);
}

static void
_pantheon_shell_dock___lambda43_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data3_->self;
	_tmp0_ = _data3_->display_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == TRUE) {
		PlankDockPreferences* _tmp3_;
		_tmp3_ = self->priv->dock_preferences;
		plank_dock_preferences_set_Monitor (_tmp3_, "");
	} else {
		gchar** plug_names = NULL;
		GdkDisplay* _tmp4_;
		gint _tmp5_ = 0;
		gchar** _tmp6_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		GtkComboBoxText* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp4_ = gtk_widget_get_display ((GtkWidget*) self);
		_tmp6_ = pantheon_shell_dock_get_monitor_plug_names (_tmp4_, &_tmp5_);
		plug_names = _tmp6_;
		plug_names_length1 = _tmp5_;
		_plug_names_size_ = plug_names_length1;
		_tmp7_ = plug_names;
		_tmp7__length1 = plug_names_length1;
		_tmp8_ = self->priv->display_combo;
		_tmp9_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp7__length1 > _tmp10_) {
			PlankDockPreferences* _tmp11_;
			gchar** _tmp12_;
			gint _tmp12__length1;
			GtkComboBoxText* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			const gchar* _tmp16_;
			_tmp11_ = self->priv->dock_preferences;
			_tmp12_ = plug_names;
			_tmp12__length1 = plug_names_length1;
			_tmp13_ = self->priv->display_combo;
			_tmp14_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = _tmp12_[_tmp15_];
			plank_dock_preferences_set_Monitor (_tmp11_, _tmp16_);
		}
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
__pantheon_shell_dock___lambda43__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	_pantheon_shell_dock___lambda43_ (self);
}

static void
_pantheon_shell_dock___lambda44_ (Block3Data* _data3_)
{
	PantheonShellDock* self;
	gboolean _tmp0_ = FALSE;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	self = _data3_->self;
	_tmp1_ = self->priv->display_combo;
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ >= 0) {
		GtkSwitch* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = _data3_->display_switch;
		_tmp5_ = gtk_switch_get_active (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ == FALSE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** plug_names = NULL;
		GdkDisplay* _tmp7_;
		gint _tmp8_ = 0;
		gchar** _tmp9_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		GtkComboBoxText* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp7_ = gtk_widget_get_display ((GtkWidget*) self);
		_tmp9_ = pantheon_shell_dock_get_monitor_plug_names (_tmp7_, &_tmp8_);
		plug_names = _tmp9_;
		plug_names_length1 = _tmp8_;
		_plug_names_size_ = plug_names_length1;
		_tmp10_ = plug_names;
		_tmp10__length1 = plug_names_length1;
		_tmp11_ = self->priv->display_combo;
		_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp10__length1 > _tmp13_) {
			PlankDockPreferences* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			GtkComboBoxText* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			const gchar* _tmp19_;
			_tmp14_ = self->priv->dock_preferences;
			_tmp15_ = plug_names;
			_tmp15__length1 = plug_names_length1;
			_tmp16_ = self->priv->display_combo;
			_tmp17_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = _tmp15_[_tmp18_];
			plank_dock_preferences_set_Monitor (_tmp14_, _tmp19_);
		}
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
__pantheon_shell_dock___lambda44__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	_pantheon_shell_dock___lambda44_ (self);
}

static void
_pantheon_shell_dock_check_for_screens_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                    gpointer self)
{
	pantheon_shell_dock_check_for_screens ((PantheonShellDock*) self);
}

static GObject *
pantheon_shell_dock_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonShellDock * self;
	Block3Data* _data3_;
	GraniteHeaderLabel* icon_header = NULL;
	GraniteHeaderLabel* _tmp0_;
	GtkRadioButton* icon_size_32 = NULL;
	GtkImage* _tmp1_;
	gchar* _tmp2_;
	GtkRadioButton* _tmp3_ = NULL;
	GtkRadioButton* icon_size_48 = NULL;
	GtkRadioButton* _tmp4_;
	GtkImage* _tmp5_;
	gchar* _tmp6_;
	GtkRadioButton* _tmp7_ = NULL;
	GtkImage* image_64 = NULL;
	gchar* _tmp8_;
	GtkImage* _tmp9_ = NULL;
	GtkRadioButton* icon_size_64 = NULL;
	GtkRadioButton* _tmp10_;
	GtkImage* _tmp11_;
	GtkWidget* _tmp12_;
	gchar* _tmp13_;
	GtkRadioButton* _tmp14_ = NULL;
	GtkRadioButton* icon_size_unsupported = NULL;
	GtkRadioButton* _tmp15_;
	GtkRadioButton* _tmp16_;
	GtkBox* icon_size_box = NULL;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkRadioButton* _tmp19_;
	GtkBox* _tmp20_;
	GtkRadioButton* _tmp21_;
	GtkBox* _tmp22_;
	GtkRadioButton* _tmp23_;
	GtkBox* icon_box = NULL;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GraniteHeaderLabel* _tmp26_;
	GtkBox* _tmp27_;
	GtkBox* _tmp28_;
	GraniteHeaderLabel* hide_header = NULL;
	GraniteHeaderLabel* _tmp29_;
	GtkRadioButton* _tmp30_;
	GtkRadioButton* _tmp31_;
	GtkRadioButton* _tmp32_;
	GtkRadioButton* _tmp33_;
	GtkRadioButton* _tmp34_;
	GtkRadioButton* _tmp35_;
	GtkRadioButton* _tmp36_;
	GtkRadioButton* _tmp37_;
	GtkRadioButton* _tmp38_;
	GtkBox* hide_radio_box = NULL;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkRadioButton* _tmp41_;
	GtkBox* _tmp42_;
	GtkRadioButton* _tmp43_;
	GtkBox* _tmp44_;
	GtkRadioButton* _tmp45_;
	GtkBox* _tmp46_;
	GtkRadioButton* _tmp47_;
	GtkBox* _tmp48_;
	GtkRadioButton* _tmp49_;
	GtkBox* hide_box = NULL;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GraniteHeaderLabel* _tmp52_;
	GtkBox* _tmp53_;
	GtkBox* _tmp54_;
	GtkComboBoxText* _tmp55_ = NULL;
	GraniteHeaderLabel* display_header = NULL;
	GraniteHeaderLabel* _tmp56_;
	GtkSwitch* _tmp57_ = NULL;
	GtkGrid* _tmp58_ = NULL;
	GtkGrid* _tmp59_;
	GraniteHeaderLabel* _tmp60_;
	GtkGrid* _tmp61_;
	GtkComboBoxText* _tmp62_;
	GtkGrid* _tmp63_;
	GtkSwitch* _tmp64_;
	GraniteHeaderLabel* pressure_header = NULL;
	GraniteHeaderLabel* _tmp65_;
	GtkLabel* pressure_subtitle = NULL;
	GtkLabel* _tmp66_ = NULL;
	GtkLabel* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkSwitch* pressure_switch = NULL;
	GtkSwitch* _tmp69_ = NULL;
	GtkGrid* _tmp70_ = NULL;
	GtkGrid* _tmp71_;
	GraniteHeaderLabel* _tmp72_;
	GtkGrid* _tmp73_;
	GtkLabel* _tmp74_;
	GtkGrid* _tmp75_;
	GtkSwitch* _tmp76_;
	GraniteHeaderLabel* translucency_header = NULL;
	GraniteHeaderLabel* _tmp77_;
	GtkLabel* translucency_subtitle = NULL;
	GtkLabel* _tmp78_ = NULL;
	GtkLabel* _tmp79_;
	GtkStyleContext* _tmp80_;
	GtkSwitch* translucency_switch = NULL;
	GtkSwitch* _tmp81_ = NULL;
	GtkGrid* translucency_grid = NULL;
	GtkGrid* _tmp82_ = NULL;
	GtkGrid* _tmp83_;
	GraniteHeaderLabel* _tmp84_;
	GtkGrid* _tmp85_;
	GtkLabel* _tmp86_;
	GtkGrid* _tmp87_;
	GtkSwitch* _tmp88_;
	GraniteHeaderLabel* indicators_header = NULL;
	GraniteHeaderLabel* _tmp89_;
	GtkBox* indicators_box = NULL;
	GtkBox* _tmp90_;
	GtkBox* _tmp91_;
	GraniteHeaderLabel* _tmp92_;
	GSettingsSchema* a11y_schema = NULL;
	GSettingsSchemaSource* _tmp93_;
	GSettingsSchema* _tmp94_;
	gboolean _tmp95_ = FALSE;
	GSettingsSchema* _tmp96_;
	GSettingsSchema* keyboard_schema = NULL;
	GSettingsSchemaSource* _tmp104_;
	GSettingsSchema* _tmp105_;
	gboolean _tmp106_ = FALSE;
	GSettingsSchema* _tmp107_;
	GtkBox* box = NULL;
	GtkBox* _tmp120_ = NULL;
	GtkBox* _tmp121_;
	GtkBox* _tmp122_;
	GtkBox* _tmp123_;
	GtkBox* _tmp124_;
	GtkBox* _tmp125_;
	GtkGrid* _tmp126_;
	GtkBox* _tmp127_;
	GtkGrid* _tmp128_;
	GtkBox* _tmp129_;
	GtkGrid* _tmp130_;
	GtkBox* _tmp131_;
	GList* _tmp132_;
	GList* _tmp133_;
	gboolean _tmp134_;
	HdyClamp* clamp = NULL;
	GtkBox* _tmp137_;
	GtkWidget* _tmp138_;
	HdyClamp* _tmp139_ = NULL;
	GtkScrolledWindow* scrolled = NULL;
	HdyClamp* _tmp140_;
	GtkWidget* _tmp141_;
	GtkScrolledWindow* _tmp142_ = NULL;
	GtkScrolledWindow* _tmp143_;
	PlankDockPreferences* _tmp144_;
	PlankDockPreferences* _tmp145_;
	GtkSwitch* _tmp146_;
	PlankDockPreferences* _tmp147_;
	gint _tmp148_;
	gint _tmp149_;
	GtkRadioButton* _tmp154_;
	GtkRadioButton* _tmp155_;
	GtkRadioButton* _tmp156_;
	GtkGrid* _tmp157_;
	PlankDockPreferences* _tmp158_;
	PlankHideType _tmp159_;
	PlankHideType _tmp160_;
	PlankDockPreferences* _tmp161_;
	PlankHideType _tmp162_;
	PlankHideType _tmp163_;
	GtkRadioButton* _tmp169_;
	GtkRadioButton* _tmp170_;
	GtkRadioButton* _tmp171_;
	GtkRadioButton* _tmp172_;
	GtkRadioButton* _tmp173_;
	GtkSwitch* _tmp174_;
	GtkSwitch* _tmp175_;
	PlankDockPreferences* _tmp176_;
	const gchar* _tmp177_;
	const gchar* _tmp178_;
	GtkSwitch* _tmp179_;
	GtkComboBoxText* _tmp180_;
	GtkComboBoxText* _tmp181_;
	GdkScreen* _tmp182_;
	GSettings* panel_settings = NULL;
	GSettings* _tmp183_;
	GSettings* _tmp184_;
	GtkSwitch* _tmp185_;
	parent_class = G_OBJECT_CLASS (pantheon_shell_dock_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_DOCK, PantheonShellDock);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = granite_header_label_new (_ ("Dock Icon Size"));
	g_object_ref_sink (_tmp0_);
	icon_header = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("dock-icon-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp1_);
	_tmp2_ = g_strdup (_ ("Small"));
	_tmp3_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	gtk_button_set_image ((GtkButton*) _tmp3_, (GtkWidget*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	icon_size_32 = _tmp3_;
	_tmp4_ = icon_size_32;
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("dock-icon-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp5_);
	_tmp6_ = g_strdup (_ ("Default"));
	_tmp7_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp4_);
	gtk_button_set_image ((GtkButton*) _tmp7_, (GtkWidget*) _tmp5_);
	_g_object_unref0 (_tmp5_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _tmp6_);
	_g_free0 (_tmp6_);
	g_object_ref_sink (_tmp7_);
	icon_size_48 = _tmp7_;
	_tmp8_ = g_strdup ("dock-icon-symbolic");
	_tmp9_ = (GtkImage*) gtk_image_new ();
	g_object_set (_tmp9_, "icon-name", _tmp8_, NULL);
	_g_free0 (_tmp8_);
	gtk_image_set_pixel_size (_tmp9_, 64);
	g_object_ref_sink (_tmp9_);
	image_64 = _tmp9_;
	_tmp10_ = icon_size_32;
	_tmp11_ = image_64;
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
	_tmp13_ = g_strdup (_ ("Large"));
	_tmp14_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp10_);
	gtk_button_set_image ((GtkButton*) _tmp14_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp13_);
	_g_free0 (_tmp13_);
	g_object_ref_sink (_tmp14_);
	icon_size_64 = _tmp14_;
	_tmp15_ = icon_size_32;
	_tmp16_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp15_);
	g_object_ref_sink (_tmp16_);
	icon_size_unsupported = _tmp16_;
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 24);
	g_object_ref_sink (_tmp17_);
	icon_size_box = _tmp17_;
	_tmp18_ = icon_size_box;
	_tmp19_ = icon_size_32;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = icon_size_box;
	_tmp21_ = icon_size_48;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = icon_size_box;
	_tmp23_ = icon_size_64;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp24_);
	icon_box = _tmp24_;
	_tmp25_ = icon_box;
	_tmp26_ = icon_header;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = icon_box;
	_tmp28_ = icon_size_box;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = granite_header_label_new (_ ("Hide Dock"));
	g_object_ref_sink (_tmp29_);
	hide_header = _tmp29_;
	_tmp30_ = (GtkRadioButton*) gtk_radio_button_new_with_label (NULL, _ ("Never"));
	g_object_ref_sink (_tmp30_);
	_data3_->never_radio = _tmp30_;
	_tmp31_ = _data3_->never_radio;
	_tmp32_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp31_, _ ("When the focused window is maximized"));
	g_object_ref_sink (_tmp32_);
	_data3_->dodge_maximized_radio = _tmp32_;
	_tmp33_ = _data3_->never_radio;
	_tmp34_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp33_, _ ("When the focused window overlaps the dock"));
	g_object_ref_sink (_tmp34_);
	_data3_->intelligent_radio = _tmp34_;
	_tmp35_ = _data3_->never_radio;
	_tmp36_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp35_, _ ("When any window overlaps the dock"));
	g_object_ref_sink (_tmp36_);
	_data3_->window_dodge_radio = _tmp36_;
	_tmp37_ = _data3_->never_radio;
	_tmp38_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp37_, _ ("When not being used"));
	g_object_ref_sink (_tmp38_);
	_data3_->auto_radio = _tmp38_;
	_tmp39_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp39_);
	hide_radio_box = _tmp39_;
	_tmp40_ = hide_radio_box;
	_tmp41_ = _data3_->never_radio;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = hide_radio_box;
	_tmp43_ = _data3_->dodge_maximized_radio;
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
	_tmp44_ = hide_radio_box;
	_tmp45_ = _data3_->intelligent_radio;
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
	_tmp46_ = hide_radio_box;
	_tmp47_ = _data3_->window_dodge_radio;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = hide_radio_box;
	_tmp49_ = _data3_->auto_radio;
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
	_tmp50_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp50_);
	hide_box = _tmp50_;
	_tmp51_ = hide_box;
	_tmp52_ = hide_header;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = hide_box;
	_tmp54_ = hide_radio_box;
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
	_tmp55_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp55_, TRUE);
	g_object_ref_sink (_tmp55_);
	_g_object_unref0 (self->priv->display_combo);
	self->priv->display_combo = _tmp55_;
	_tmp56_ = granite_header_label_new (_ ("Dock on Primary Display"));
	g_object_ref_sink (_tmp56_);
	display_header = _tmp56_;
	_tmp57_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp57_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp57_);
	_data3_->display_switch = _tmp57_;
	_tmp58_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp58_, 12);
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp58_, TRUE);
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (self->priv->display_grid);
	self->priv->display_grid = _tmp58_;
	_tmp59_ = self->priv->display_grid;
	_tmp60_ = display_header;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 0, 0, 1, 1);
	_tmp61_ = self->priv->display_grid;
	_tmp62_ = self->priv->display_combo;
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp62_, 0, 1, 1, 1);
	_tmp63_ = self->priv->display_grid;
	_tmp64_ = _data3_->display_switch;
	gtk_grid_attach (_tmp63_, (GtkWidget*) _tmp64_, 1, 0, 1, 2);
	_tmp65_ = granite_header_label_new (_ ("Dock Pressure Reveal"));
	g_object_ref_sink (_tmp65_);
	pressure_header = _tmp65_;
	_tmp66_ = (GtkLabel*) gtk_label_new (_ ("Prevent accidental reveals by moving the pointer past the display edge" \
". Only works with some devices."));
	g_object_set (_tmp66_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp66_, (gfloat) 0);
	g_object_ref_sink (_tmp66_);
	pressure_subtitle = _tmp66_;
	_tmp67_ = pressure_subtitle;
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
	gtk_style_context_add_class (_tmp68_, GTK_STYLE_CLASS_DIM_LABEL);
	_tmp69_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp69_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp69_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp69_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp69_);
	pressure_switch = _tmp69_;
	_tmp70_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp70_, 12);
	g_object_ref_sink (_tmp70_);
	_data3_->pressure_grid = _tmp70_;
	_tmp71_ = _data3_->pressure_grid;
	_tmp72_ = pressure_header;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 0, 1, 1);
	_tmp73_ = _data3_->pressure_grid;
	_tmp74_ = pressure_subtitle;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 0, 1, 1, 1);
	_tmp75_ = _data3_->pressure_grid;
	_tmp76_ = pressure_switch;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 1, 0, 1, 2);
	_tmp77_ = granite_header_label_new (_ ("Panel Translucency"));
	g_object_ref_sink (_tmp77_);
	translucency_header = _tmp77_;
	_tmp78_ = (GtkLabel*) gtk_label_new (_ ("Automatically transparent or opaque based on the wallpaper"));
	g_object_set (_tmp78_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp78_, (gfloat) 0);
	g_object_ref_sink (_tmp78_);
	translucency_subtitle = _tmp78_;
	_tmp79_ = translucency_subtitle;
	_tmp80_ = gtk_widget_get_style_context ((GtkWidget*) _tmp79_);
	gtk_style_context_add_class (_tmp80_, GTK_STYLE_CLASS_DIM_LABEL);
	_tmp81_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp81_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp81_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp81_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp81_);
	translucency_switch = _tmp81_;
	_tmp82_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp82_, 12);
	g_object_ref_sink (_tmp82_);
	translucency_grid = _tmp82_;
	_tmp83_ = translucency_grid;
	_tmp84_ = translucency_header;
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 0, 0, 1, 1);
	_tmp85_ = translucency_grid;
	_tmp86_ = translucency_subtitle;
	gtk_grid_attach (_tmp85_, (GtkWidget*) _tmp86_, 0, 1, 1, 1);
	_tmp87_ = translucency_grid;
	_tmp88_ = translucency_switch;
	gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, 1, 0, 1, 2);
	_tmp89_ = granite_header_label_new (_ ("Show in Panel"));
	g_object_ref_sink (_tmp89_);
	indicators_header = _tmp89_;
	_tmp90_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp90_);
	indicators_box = _tmp90_;
	_tmp91_ = indicators_box;
	_tmp92_ = indicators_header;
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
	_tmp93_ = g_settings_schema_source_get_default ();
	_tmp94_ = g_settings_schema_source_lookup (_tmp93_, "io.elementary.desktop.wingpanel.a11y", TRUE);
	a11y_schema = _tmp94_;
	_tmp96_ = a11y_schema;
	if (_tmp96_ != NULL) {
		GSettingsSchema* _tmp97_;
		_tmp97_ = a11y_schema;
		_tmp95_ = g_settings_schema_has_key (_tmp97_, "show-indicator");
	} else {
		_tmp95_ = FALSE;
	}
	if (_tmp95_) {
		GtkCheckButton* a11y_check = NULL;
		GtkCheckButton* _tmp98_;
		GtkBox* _tmp99_;
		GtkCheckButton* _tmp100_;
		GSettings* a11y_settings = NULL;
		GSettings* _tmp101_;
		GSettings* _tmp102_;
		GtkCheckButton* _tmp103_;
		_tmp98_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Accessibility"));
		g_object_ref_sink (_tmp98_);
		a11y_check = _tmp98_;
		_tmp99_ = indicators_box;
		_tmp100_ = a11y_check;
		gtk_container_add ((GtkContainer*) _tmp99_, (GtkWidget*) _tmp100_);
		_tmp101_ = g_settings_new ("io.elementary.desktop.wingpanel.a11y");
		a11y_settings = _tmp101_;
		_tmp102_ = a11y_settings;
		_tmp103_ = a11y_check;
		g_settings_bind (_tmp102_, "show-indicator", (GObject*) _tmp103_, "active", G_SETTINGS_BIND_DEFAULT);
		_g_object_unref0 (a11y_settings);
		_g_object_unref0 (a11y_check);
	}
	_tmp104_ = g_settings_schema_source_get_default ();
	_tmp105_ = g_settings_schema_source_lookup (_tmp104_, "io.elementary.wingpanel.keyboard", TRUE);
	keyboard_schema = _tmp105_;
	_tmp107_ = keyboard_schema;
	if (_tmp107_ != NULL) {
		GSettingsSchema* _tmp108_;
		_tmp108_ = keyboard_schema;
		_tmp106_ = g_settings_schema_has_key (_tmp108_, "capslock");
	} else {
		_tmp106_ = FALSE;
	}
	if (_tmp106_) {
		GtkCheckButton* caps_check = NULL;
		GtkCheckButton* _tmp109_;
		GtkCheckButton* num_check = NULL;
		GtkCheckButton* _tmp110_;
		GtkBox* _tmp111_;
		GtkCheckButton* _tmp112_;
		GtkBox* _tmp113_;
		GtkCheckButton* _tmp114_;
		GSettings* keyboard_settings = NULL;
		GSettings* _tmp115_;
		GSettings* _tmp116_;
		GtkCheckButton* _tmp117_;
		GSettings* _tmp118_;
		GtkCheckButton* _tmp119_;
		_tmp109_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Caps Lock ⇪"));
		g_object_ref_sink (_tmp109_);
		caps_check = _tmp109_;
		_tmp110_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Num Lock"));
		g_object_ref_sink (_tmp110_);
		num_check = _tmp110_;
		_tmp111_ = indicators_box;
		_tmp112_ = caps_check;
		gtk_container_add ((GtkContainer*) _tmp111_, (GtkWidget*) _tmp112_);
		_tmp113_ = indicators_box;
		_tmp114_ = num_check;
		gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
		_tmp115_ = g_settings_new ("io.elementary.wingpanel.keyboard");
		keyboard_settings = _tmp115_;
		_tmp116_ = keyboard_settings;
		_tmp117_ = caps_check;
		g_settings_bind (_tmp116_, "capslock", (GObject*) _tmp117_, "active", G_SETTINGS_BIND_DEFAULT);
		_tmp118_ = keyboard_settings;
		_tmp119_ = num_check;
		g_settings_bind (_tmp118_, "numlock", (GObject*) _tmp119_, "active", G_SETTINGS_BIND_DEFAULT);
		_g_object_unref0 (keyboard_settings);
		_g_object_unref0 (num_check);
		_g_object_unref0 (caps_check);
	}
	_tmp120_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp120_, 12);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp120_, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp120_, 12);
	g_object_ref_sink (_tmp120_);
	box = _tmp120_;
	_tmp121_ = box;
	_tmp122_ = icon_box;
	gtk_container_add ((GtkContainer*) _tmp121_, (GtkWidget*) _tmp122_);
	_tmp123_ = box;
	_tmp124_ = hide_box;
	gtk_container_add ((GtkContainer*) _tmp123_, (GtkWidget*) _tmp124_);
	_tmp125_ = box;
	_tmp126_ = _data3_->pressure_grid;
	gtk_container_add ((GtkContainer*) _tmp125_, (GtkWidget*) _tmp126_);
	_tmp127_ = box;
	_tmp128_ = self->priv->display_grid;
	gtk_container_add ((GtkContainer*) _tmp127_, (GtkWidget*) _tmp128_);
	_tmp129_ = box;
	_tmp130_ = translucency_grid;
	gtk_container_add ((GtkContainer*) _tmp129_, (GtkWidget*) _tmp130_);
	_tmp131_ = indicators_box;
	_tmp132_ = gtk_container_get_children ((GtkContainer*) _tmp131_);
	_tmp133_ = _tmp132_;
	_tmp134_ = g_list_length (_tmp133_) > ((guint) 1);
	(_tmp133_ == NULL) ? NULL : (_tmp133_ = (g_list_free (_tmp133_), NULL));
	if (_tmp134_) {
		GtkBox* _tmp135_;
		GtkBox* _tmp136_;
		_tmp135_ = box;
		_tmp136_ = indicators_box;
		gtk_container_add ((GtkContainer*) _tmp135_, (GtkWidget*) _tmp136_);
	}
	_tmp137_ = box;
	_tmp138_ = _g_object_ref0 ((GtkWidget*) _tmp137_);
	_tmp139_ = (HdyClamp*) hdy_clamp_new ();
	g_object_set ((GtkContainer*) _tmp139_, "child", _tmp138_, NULL);
	_g_object_unref0 (_tmp138_);
	g_object_ref_sink (_tmp139_);
	clamp = _tmp139_;
	_tmp140_ = clamp;
	_tmp141_ = _g_object_ref0 ((GtkWidget*) _tmp140_);
	_tmp142_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set ((GtkContainer*) _tmp142_, "child", _tmp141_, NULL);
	_g_object_unref0 (_tmp141_);
	g_object_ref_sink (_tmp142_);
	scrolled = _tmp142_;
	_tmp143_ = scrolled;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp143_);
	_tmp144_ = plank_dock_preferences_new ("dock1");
	_g_object_unref0 (self->priv->dock_preferences);
	self->priv->dock_preferences = _tmp144_;
	_tmp145_ = self->priv->dock_preferences;
	_tmp146_ = pressure_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp145_, "PressureReveal", (GObject*) _tmp146_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	plank_paths_initialize ("plank", CONSTANTS_PLANKDATADIR);
	pantheon_shell_dock_check_for_screens (self);
	_tmp147_ = self->priv->dock_preferences;
	_tmp148_ = plank_dock_preferences_get_IconSize (_tmp147_);
	_tmp149_ = _tmp148_;
	switch (_tmp149_) {
		case 32:
		{
			GtkRadioButton* _tmp150_;
			_tmp150_ = icon_size_32;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp150_, TRUE);
			break;
		}
		case 48:
		{
			GtkRadioButton* _tmp151_;
			_tmp151_ = icon_size_48;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp151_, TRUE);
			break;
		}
		case 64:
		{
			GtkRadioButton* _tmp152_;
			_tmp152_ = icon_size_64;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp152_, TRUE);
			break;
		}
		default:
		{
			GtkRadioButton* _tmp153_;
			_tmp153_ = icon_size_unsupported;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp153_, TRUE);
			g_debug ("Dock.vala:219: Unsupported dock icon size");
		}
	}
	_tmp154_ = icon_size_32;
	g_signal_connect_object ((GtkToggleButton*) _tmp154_, "toggled", (GCallback) __pantheon_shell_dock___lambda35__gtk_toggle_button_toggled, self, 0);
	_tmp155_ = icon_size_48;
	g_signal_connect_object ((GtkToggleButton*) _tmp155_, "toggled", (GCallback) __pantheon_shell_dock___lambda36__gtk_toggle_button_toggled, self, 0);
	_tmp156_ = icon_size_64;
	g_signal_connect_object ((GtkToggleButton*) _tmp156_, "toggled", (GCallback) __pantheon_shell_dock___lambda37__gtk_toggle_button_toggled, self, 0);
	_tmp157_ = _data3_->pressure_grid;
	_tmp158_ = self->priv->dock_preferences;
	_tmp159_ = plank_dock_preferences_get_HideMode (_tmp158_);
	_tmp160_ = _tmp159_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp157_, _tmp160_ != PLANK_HIDE_TYPE_NONE);
	_tmp161_ = self->priv->dock_preferences;
	_tmp162_ = plank_dock_preferences_get_HideMode (_tmp161_);
	_tmp163_ = _tmp162_;
	switch (_tmp163_) {
		case PLANK_HIDE_TYPE_NONE:
		{
			GtkRadioButton* _tmp164_;
			_tmp164_ = _data3_->never_radio;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp164_, TRUE);
			break;
		}
		case PLANK_HIDE_TYPE_DODGE_MAXIMIZED:
		{
			GtkRadioButton* _tmp165_;
			_tmp165_ = _data3_->dodge_maximized_radio;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp165_, TRUE);
			break;
		}
		case PLANK_HIDE_TYPE_INTELLIGENT:
		{
			GtkRadioButton* _tmp166_;
			_tmp166_ = _data3_->intelligent_radio;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp166_, TRUE);
			break;
		}
		case PLANK_HIDE_TYPE_WINDOW_DODGE:
		{
			GtkRadioButton* _tmp167_;
			_tmp167_ = _data3_->window_dodge_radio;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp167_, TRUE);
			break;
		}
		case PLANK_HIDE_TYPE_AUTO:
		{
			GtkRadioButton* _tmp168_;
			_tmp168_ = _data3_->auto_radio;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp168_, TRUE);
			break;
		}
		default:
		break;
	}
	_tmp169_ = _data3_->never_radio;
	g_signal_connect_data ((GtkToggleButton*) _tmp169_, "toggled", (GCallback) __pantheon_shell_dock___lambda38__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp170_ = _data3_->dodge_maximized_radio;
	g_signal_connect_data ((GtkToggleButton*) _tmp170_, "toggled", (GCallback) __pantheon_shell_dock___lambda39__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp171_ = _data3_->intelligent_radio;
	g_signal_connect_data ((GtkToggleButton*) _tmp171_, "toggled", (GCallback) __pantheon_shell_dock___lambda40__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp172_ = _data3_->window_dodge_radio;
	g_signal_connect_data ((GtkToggleButton*) _tmp172_, "toggled", (GCallback) __pantheon_shell_dock___lambda41__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp173_ = _data3_->auto_radio;
	g_signal_connect_data ((GtkToggleButton*) _tmp173_, "toggled", (GCallback) __pantheon_shell_dock___lambda42__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp174_ = _data3_->display_switch;
	g_signal_connect_data ((GObject*) _tmp174_, "notify::active", (GCallback) __pantheon_shell_dock___lambda43__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp175_ = _data3_->display_switch;
	_tmp176_ = self->priv->dock_preferences;
	_tmp177_ = plank_dock_preferences_get_Monitor (_tmp176_);
	_tmp178_ = _tmp177_;
	gtk_switch_set_active (_tmp175_, g_strcmp0 (_tmp178_, "") == 0);
	_tmp179_ = _data3_->display_switch;
	_tmp180_ = self->priv->display_combo;
	g_object_bind_property_with_closures ((GObject*) _tmp179_, "active", (GObject*) _tmp180_, "sensitive", G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp181_ = self->priv->display_combo;
	g_signal_connect_data ((GObject*) _tmp181_, "notify::active", (GCallback) __pantheon_shell_dock___lambda44__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp182_ = gtk_widget_get_screen ((GtkWidget*) self);
	g_signal_connect_object (_tmp182_, "monitors-changed", (GCallback) _pantheon_shell_dock_check_for_screens_gdk_screen_monitors_changed, self, 0);
	_tmp183_ = g_settings_new (PANTHEON_SHELL_DOCK_PANEL_SCHEMA);
	panel_settings = _tmp183_;
	_tmp184_ = panel_settings;
	_tmp185_ = translucency_switch;
	g_settings_bind (_tmp184_, PANTHEON_SHELL_DOCK_TRANSLUCENCY_KEY, (GObject*) _tmp185_, "active", G_SETTINGS_BIND_DEFAULT);
	_g_object_unref0 (panel_settings);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (clamp);
	_g_object_unref0 (box);
	_g_settings_schema_unref0 (keyboard_schema);
	_g_settings_schema_unref0 (a11y_schema);
	_g_object_unref0 (indicators_box);
	_g_object_unref0 (indicators_header);
	_g_object_unref0 (translucency_grid);
	_g_object_unref0 (translucency_switch);
	_g_object_unref0 (translucency_subtitle);
	_g_object_unref0 (translucency_header);
	_g_object_unref0 (pressure_switch);
	_g_object_unref0 (pressure_subtitle);
	_g_object_unref0 (pressure_header);
	_g_object_unref0 (display_header);
	_g_object_unref0 (hide_box);
	_g_object_unref0 (hide_radio_box);
	_g_object_unref0 (hide_header);
	_g_object_unref0 (icon_box);
	_g_object_unref0 (icon_size_box);
	_g_object_unref0 (icon_size_unsupported);
	_g_object_unref0 (icon_size_64);
	_g_object_unref0 (image_64);
	_g_object_unref0 (icon_size_48);
	_g_object_unref0 (icon_size_32);
	_g_object_unref0 (icon_header);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return obj;
}

static void
pantheon_shell_dock_class_init (PantheonShellDockClass * klass,
                                gpointer klass_data)
{
	pantheon_shell_dock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonShellDock_private_offset);
	G_OBJECT_CLASS (klass)->constructor = pantheon_shell_dock_constructor;
	G_OBJECT_CLASS (klass)->finalize = pantheon_shell_dock_finalize;
}

static void
pantheon_shell_dock_instance_init (PantheonShellDock * self,
                                   gpointer klass)
{
	self->priv = pantheon_shell_dock_get_instance_private (self);
}

static void
pantheon_shell_dock_finalize (GObject * obj)
{
	PantheonShellDock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_DOCK, PantheonShellDock);
	_g_object_unref0 (self->priv->display_grid);
	_g_object_unref0 (self->priv->display_combo);
	_g_object_unref0 (self->priv->dock_preferences);
	G_OBJECT_CLASS (pantheon_shell_dock_parent_class)->finalize (obj);
}

static GType
pantheon_shell_dock_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonShellDockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_shell_dock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonShellDock), 0, (GInstanceInitFunc) pantheon_shell_dock_instance_init, NULL };
	GType pantheon_shell_dock_type_id;
	pantheon_shell_dock_type_id = g_type_register_static (gtk_box_get_type (), "PantheonShellDock", &g_define_type_info, 0);
	PantheonShellDock_private_offset = g_type_add_instance_private (pantheon_shell_dock_type_id, sizeof (PantheonShellDockPrivate));
	return pantheon_shell_dock_type_id;
}

GType
pantheon_shell_dock_get_type (void)
{
	static volatile gsize pantheon_shell_dock_type_id__once = 0;
	if (g_once_init_enter (&pantheon_shell_dock_type_id__once)) {
		GType pantheon_shell_dock_type_id;
		pantheon_shell_dock_type_id = pantheon_shell_dock_get_type_once ();
		g_once_init_leave (&pantheon_shell_dock_type_id__once, pantheon_shell_dock_type_id);
	}
	return pantheon_shell_dock_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

